import sys, getopt
import numpy
import itertools

def main(argv):
   inputfile = ''
   outputfile = ''
   window= 1
   
   if len(argv[1:]) == 0:
#        print ('seq2motif.py -i <inputfile> -o <outputfile> -w <window> -x <extension>')
        print ("\nProgram to generate patterns of given size from PSSM matrix.\n")
        print ("Usage:python pssm2pat -i pssm.out –o pssm_pat –w 5\n")
        print ('-i\tInput file having pssm profile generated by using (seq2pssm_imp)\n-o\toutputFile\n-w\tWindow size generated from PSSM matrix\n')
        sys.exit()
   
   try:
       # opts is a list of returning key-value pairs, args is the options left after striped
       # the short options 'hi:o:', if an option requires an input, it should be followed by a ":"
       # the long options 'ifile=' is an option that requires an input, followed by a "="
      opts, args = getopt.getopt(argv,"i:o:w:",["ifile=","ofile=","window="])
   except getopt.GetoptError:
      print ('pssm2pat.py -i <inputfile> -o <outputfile> -n <number>')
      sys.exit(2)
   for opt, arg in opts:
      if opt == '-h':
         print ('pssm2pat.py -i <inputfile> -o <outputfile> -n <number>')
         sys.exit()
      elif opt in ("-i", "--ifile"):
         inputfile = arg
      elif opt in ("-o", "--ofile"):
         outputfile = arg
      elif opt in ("-w", "--window"):
         window = int(sys.argv[6])
   
   with open(inputfile,'r') as f:
    g = list(f)
	
   orig_stdout = sys.stdout
   n = open(outputfile,'w')
   sys.stdout = n	
	
   no_insert_seq = (window-1)/2
   x1 = 'X, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0\n'
   i = 0
   j = 0
   i1 = 0
   j1 = 0
   l = 0
   b = []

   while j < no_insert_seq:
    g.insert(0,x1)
    g.insert(len(g),x1)
    j += 1    
	
   while i < len(g) :
    g[i] = g[i].replace('\n','')
    g[i] = g[i].split(",")
    i += 1		
	
   hh = numpy.zeros(shape=(len(g),len(g[0])-1), dtype = object)
   while i1 < len(g) :
    while j1 < len(g[0]) :
     if j1 > 0 :
      hh[i1][j1-1] = g[i1][j1]
     j1 += 1
    j1 = 0
    i1 += 1
	
   while l < len(hh) :
    if (l + window) < len(g)+1 :
     b = hh[l:l+window]
     print(str(list(itertools.chain(*b))).replace('[','').replace(']','').replace("'",""))
     #print(str(b).replace('[','').replace('], ','\n'))
    l += 1

  #ff = b.tolist()
  # print(str(b).replace('[','').replace('], ','\n'))   
	
if __name__ == "__main__":
   #main(sys.argv[1:])
   main(sys.argv[1:])	
      
