#=================================================================
# program developed To normalize pssm profile based on 1/(1+e-(x/100)) formula
# Usage: pssm_comp -i pssm.out –o pssm_comp
#
#=================================================================
#!/usr/bin/python

import sys, getopt
from math import exp


def main(argv):
   inputfile = ''
   outputfile = ''
   if len(argv[1:])==0:
       #print("\n Usage for displaying on screen: python pro2dpc -i seq.sfa -o seq.out")
       print("usage python pssm_comp -i pssm.out –o pssm_comp\n")
       print("-i\t Input file having pssm profile generated by using (seq2pssm_imp.pl -i seq1.fa -o seq1.out -d nr) and then scaled by using (pssm_n4.pl -i pssm.out –o pssm_n4)\n-o\t Output file having normalized value ")
       sys.exit()
   try:
      opts, args = getopt.getopt(argv,"hi:o:",["ifile=","ofile="])
   except getopt.GetoptError:
      print ('pssm_comp -i pssm_n4 –o pssm_comp.out')
      sys.exit(2)
   for opt, arg in opts:
      if opt == '-h':
         print ('pssm_comp -i pssm_n4 –o pssm_comp.out')
         sys.exit()
      elif opt in ("-i", "--ifile"):
         inputfile = arg
      elif opt in ("-o", "--ofile"):
         outputfile = arg

   with open(inputfile,'r') as f:
    g = list(f)

   orig_stdout = sys.stdout
   n = open(outputfile,'w')
   sys.stdout = n

   #import numpy
   #bb = numpy.zeros(shape=(len(g),len(g[0])))

   i = 0
   j = 0
   i1 = 0
   j1 = 0
   i2 = 0
   k1 = 0
   sum = 0
   
   while i < len(g) :
    g[i] = g[i].replace('\n','')
    #g[i] = g[i].split(",")
    #g[i] =[j.split() for j in g[i]]
    i += 1
    
   g = [j.split() for j in g] 
    
    
   while i1 < len(g) :
    while j1 < len(g[0])  : # last column has vlue -32768
     if j1 > 0 :
      while i2 < len(g) :
       sum = float(g[i1][j1])
       if i1 < i2 :
        if g[i1][0] == g[i2][0] :
         g[i1][j1] = sum + float(g[i2][j1])
       i2 += 1
     i2 = 0
     sum = 0
     j1 += 1
    j1 = 0
    i1 += 1 

   #a = [x for x in a if x != 20]   
   gg = []
   while i2 < len(g) :
    #gg.append([])
    while j1 < len(g[0]) :
     if j1 > 0 :
      while k1 < len(g):
       if g[i2][0] == g[k1][0] :
        if float(g[i2][j1]) > float(g[k1][j1]) :
         g[k1][j1] = 0
         #gg.append(g[k1][j1])
       #else :	
        #gg.append(g[i2][j1])
       k1 += 1
     k1 = 0
     j1 += 1
    j1 = 0
    i2 += 1     
       
   while k1 < len(g) :
    gg.append([])
    while j1 < len(g[0]) :
     if j1 > 0 :
      if g[k1][j1] != 0 :
       gg[k1].append(float(g[k1][j1])/len(g))
           
     j1 += 1
    j1 = 0
    k1 += 1    
         
   res = list(filter(None, gg))
    
   for r in res:
    for c in r:
     print(c,end = ",")
    print()  

if __name__ == "__main__":
   #main(sys.argv[1:])
   main(sys.argv[1:])
