#=================================================================
# program developed To normalize pssm profile based on 1/(1+e-(x/100)) formula
# Usage: pssm_n4 -i pssm.out –o pssm_n4
#
#=================================================================
#!/usr/bin/python

import sys, getopt
from math import exp


def main(argv):
   inputfile = ''
   outputfile = ''
   if len(argv[1:])==0:
       #print("\n Usage for displaying on screen: python pro2dpc -i seq.sfa -o seq.out")
       print("usage python pssm_n4 -i pssm.out –o pssm_n4\n")
       print("-i\t Input file having pssm profile generated by using (seq2pssm_imp.pl -i seq1.fa -o seq1.out -d nr)\n-o\t Output file having normalized value ")
       sys.exit()
   try:
      opts, args = getopt.getopt(argv,"hi:o:",["ifile=","ofile="])
   except getopt.GetoptError:
      print ('pssm_n4.py -i <inputfile> -o <outputfile>')
      sys.exit(2)
   for opt, arg in opts:
      if opt == '-h':
         print ('pssm_n4.py -i <inputfile> -o <outputfile>')
         sys.exit()
      elif opt in ("-i", "--ifile"):
         inputfile = arg
      elif opt in ("-o", "--ofile"):
         outputfile = arg

   with open(inputfile,'r') as f:
    g = list(f)

   orig_stdout = sys.stdout
   n = open(outputfile,'w')
   sys.stdout = n

   #import numpy
   #bb = numpy.zeros(shape=(len(g),len(g[0])))

   i = 0
   j = 0
   i1 = 0
   j1 = 0
   
   while i < len(g) :
    g[i] = g[i].replace('\n','')
    g[i] = g[i].split(",")
    i += 1

   while i1 < len(g) :
    while j1 < len(g[0]) : # last column has vlue -32768
     if j1 > 0 :
      r = float(g[i1][j1])/100 
      g[i1][j1] = 1/(1+exp(-r))
      g[i1][j1] = round(g[i1][j1],4)
     j1 += 1
    j1 = 0
    i1 += 1

   for j in g :
    print(*j)

if __name__ == "__main__":
   #main(sys.argv[1:])
   main(sys.argv[1:])
